package org.objectweb.fractal.cecilia.adl.maven.plugin;

import java.util.ArrayList;
import java.util.List;

import org.apache.maven.project.MavenProject;

public class Adl implements CeciliaAdlLauncherArguments {
  private String definition;
  private String execname;

  public List getArguments(MavenProject project) {
    List result = new ArrayList(1);
    result.add(this.toString());
    return result;
  }

  public String toString() {
    // Check the correctness of the definition name.
    if(definition.contains(":")){
      throw new RuntimeException("A <definition> name cannot contain ':'.");
    }
    if (execname == null) {
      return definition;
    } else {
      return definition+':'+execname;
    }
  }
}
